/*
 * @(#)Crypto.java
 * 
 * Copyright(c) 2005 Infocity Inc. All Rights Reserved.
 */
package info.dragonlady.crypto;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

/**
 * 暗号化・復号化クラス。
 * 
 * @author Hiroshi.Ebata(INFOCITY)
 * @version  $Revision: 1.4 $ $Date: 2006/03/09 14:43:01 $
 */
public class Crypto {

	/**
	 * 暗号化・復号化に使用するキー。
	 */
	private static final byte[] buf = {57, 6, 118, -83, 6, 53, -36, 88, -55, -29, 65, -7, 50, 31, 98, 120};

	/**
	 * デフォルト文字エンコーディング。
	 */
	private static final String defaultCharsetName = "UTF-8";

	/**
	 * 変換アルゴリズム名。
	 */
	private static final String transformation = "AES";

	/**
	 * 暗号化キー生成。
	 * 
	 * @return String 暗号化キー
	 * @throws CryptException
	 */
	public static byte[] generateKey() throws NoSuchAlgorithmException, IllegalStateException {
		KeyGenerator keyGen = KeyGenerator.getInstance(Crypto.transformation);
		keyGen.init(128);
		Key key = keyGen.generateKey();
		return key.getEncoded();
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化対象
	 * @return byte[] 暗号化されたバイト配列
	 * @throws CryptException
	 */
	public static byte[] encrypt(byte[] source) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException {
		return Crypto.encrypt(source, Crypto.buf);
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化対象
	 * @param key 暗号化キー
	 * @return byte[] 暗号化されたバイト配列
	 * @throws CryptException
	 */
	public static byte[] encrypt(byte[] source, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException {
		if(source == null) {
			return null;
		}
		SecretKeySpec secretKey = new SecretKeySpec(key, Crypto.transformation);

		Cipher cipher = Cipher.getInstance(Crypto.transformation);
		cipher.init(Cipher.ENCRYPT_MODE, secretKey);
		return cipher.doFinal(source);
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化する文字列
	 * @return String 暗号化された文字列
	 * @throws CryptException
	 */
	public static String encrypt(String source) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return Crypto.encrypt(source, Crypto.defaultCharsetName);
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化する文字列
	 * @param charsetName 暗号化する文字列の文字セット
	 * @return String 暗号化された文字列
	 * @throws CryptException
	 */
	public static String encrypt(String source, String charsetName) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return encrypt(source, Crypto.defaultCharsetName, Crypto.buf);
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化する文字列
	 * @param key 暗号化キー
	 * @return String 暗号化された文字列
	 * @throws CryptException
	 */
	public static String encrypt(String source, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return encrypt(source, Crypto.defaultCharsetName, key);
	}

	/**
	 * 暗号化処理。
	 * 
	 * @param source 暗号化する文字列
	 * @param charsetName 暗号化する文字列の文字セット
	 * @param key 暗号化キー
	 * @return String 暗号化された文字列
	 * @throws CryptException
	 */
	public static String encrypt(String source, String charsetName, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		if(source == null) {
			return null;
		}
		byte[] encrypted = Crypto.encrypt(source.getBytes(charsetName), key);
		// byte配列を16進数の文字列に変換
		return Crypto.toHexString(encrypted);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化された文字列
	 * @return String 復号化された文字列
	 * @throws CryptException
	 */
	public static String decrypt(String encrypted) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return Crypto.decrypt(encrypted, Crypto.defaultCharsetName);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化された文字列
	 * @param charsetName 復号化する文字列の文字セット
	 * @return String 復号化された文字列
	 * @throws CryptException
	 */
	public static String decrypt(String encrypted, String charsetName) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return Crypto.decrypt(encrypted, Crypto.defaultCharsetName, Crypto.buf);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化された文字列
	 * @param key 暗号化キー
	 * @return String 復号化された文字列
	 * @throws CryptException
	 */
	public static String decrypt(String encrypted, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		return Crypto.decrypt(encrypted, Crypto.defaultCharsetName, key);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化された文字列
	 * @param charsetName 復号化する文字列の文字セット
	 * @param key 暗号化キー
	 * @return String 復号化された文字列
	 * @throws CryptException
	 */
	public static String decrypt(String encrypted, String charsetName, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
		if(encrypted == null) {
			return null;
		}
		// 16進数の文字列をbyte配列に変換
		byte[] encByte = Crypto.toByteArray(encrypted);
		byte[] decrypted = Crypto.decrypt(encByte, key);
		return new String(decrypted, charsetName);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化されたバイト配列
	 * @return byte[] 復号化されたバイト配列
	 * @throws CryptException
	 */
	public static byte[] decrypt(byte[] encrypted) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException {
		return Crypto.decrypt(encrypted, Crypto.buf);
	}

	/**
	 * 復号化処理。
	 * 
	 * @param encrypted 暗号化されたバイト配列
	 * @param key 暗号化キー
	 * @return byte[] 復号化されたバイト配列
	 * @throws CryptException
	 */
	public static byte[] decrypt(byte[] encrypted, byte[] key) throws NoSuchPaddingException, NoSuchAlgorithmException, InvalidKeyException, IllegalStateException, IllegalBlockSizeException, BadPaddingException {
		if(encrypted == null) {
			return null;
		}
		SecretKeySpec secretKey = new SecretKeySpec(key, Crypto.transformation);
		Cipher cipher = Cipher.getInstance(Crypto.transformation);
		cipher.init(Cipher.DECRYPT_MODE, secretKey);
		return cipher.doFinal(encrypted);
	}

	/**
	 * 指定文字列に対してMD5でハッシュ値を取得する。
	 * 
	 * @param str 文字列
	 * @return String MD5ハッシュ文字列
	 */
	public static String md5(String str) throws NoSuchAlgorithmException {
		return hash("MD5", str);
	}

	/**
	 * 指定文字列に対してSHA1でハッシュ値を取得する。
	 * 
	 * @param str 文字列
	 * @return String SHA1ハッシュ文字列
	 */
	public static String sha1(String str) throws NoSuchAlgorithmException {
		return hash("SHA1", str);
	}

	/**
	 * 指定文字列に対して指定アルゴリズムでハッシュ値を取得する。
	 * 
	 * @param algorithm アルゴリズム
	 * @param str 文字列
	 * @return String ハッシュ文字列
	 */
	public static String hash(String algorithm, String str) throws NoSuchAlgorithmException {
		if(str == null) {
			return null;
		}
		MessageDigest md = MessageDigest.getInstance(algorithm);
		md.update(str.getBytes());
		byte[] digest = md.digest();

		return Crypto.toHexString(digest);
	}

	/**
	 * バイト配列を16進数文字列に変換する。
	 * 
	 * @param b バイト配列
	 * @return String 16進数文字列
	 */
	public static final String toHexString(byte[] b) {
		StringBuffer buffer = new StringBuffer();
		for(int i = 0; i < b.length; i++) {
			String tmp = Integer.toHexString(b[i] & 0xff);
			if (tmp.length() == 1) {
				buffer.append('0').append(tmp);
			} else {
				buffer.append(tmp);
			}
		}
		return buffer.toString();
	}

	/**
	 * 16進数文字列をバイト配列に変換する。
	 * 
	 * @param hex 16進数文字列
	 * @return byte[] バイト配列
	 */
	public static final byte[] toByteArray(String hex) {
		byte[] b = new byte[hex.length() / 2];
		for(int i = 0; i < hex.length(); i+=2) {
			String byteStr = hex.substring(i, i+2);
			b[i / 2] = new Integer(Integer.parseInt(byteStr, 16)).byteValue();
		}
		return b;
	}

	/**
	 * ランダムな文字列を生成する。
	 * 
	 * @param count 文字列の長さ
	 * @return String ランダム文字列
	 */
	public static final String random(int count) {
		if (count < 1) {
			return "";
		}
		int end = 'z' + 1;
		int start = ' ';

		char[] buffer = new char[count];
		int gap = end - start;

		while (count-- != 0) {
			Random random = new Random();
			char ch = (char) (random.nextInt(gap) + start);
			if (Character.isLetter(ch) || Character.isDigit(ch)) {
				if(ch >= 56320 && ch <= 57343) {
					if(count == 0) {
						count++;
					} else {
						// low surrogate, insert high surrogate after putting it in
						buffer[count] = ch;
						count--;
						buffer[count] = (char) (55296 + random.nextInt(128));
					}
				} else if(ch >= 55296 && ch <= 56191) {
					if(count == 0) {
						count++;
					} else {
						// high surrogate, insert low surrogate before putting it in
						buffer[count] = (char) (56320 + random.nextInt(128));
						count--;
						buffer[count] = ch;
					}
				} else if(ch >= 56192 && ch <= 56319) {
					// private high surrogate, no effing clue, so skip it
					count++;
				} else {
					buffer[count] = ch;
				}
			} else {
				count++;
			}
		}
		return new String(buffer);
	}

}
